/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.wahlrechtspruefung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.wahlrechtspruefung.boundary.AbstractWahlrechtspruefungSearchParameters;
import de.ivu.elect.business.wahlrechtspruefung.boundary.WahlrechtspruefungChangeEvent;
import de.ivu.elect.business.wahlrechtspruefung.boundary.WahlrechtspruefungConversationStore;
import de.ivu.elect.business.wahlrechtspruefung.boundary.WahlrechtspruefungExtendedDAO;
import de.ivu.elect.business.wahlrechtspruefung.boundary.WahlrechtspruefungSearch;
import de.ivu.elect.business.wahlrechtspruefung.boundary.WahlrechtspruefungSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.wahlrechtspruefung.entity.Wahlrechtspruefung;
import de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefungMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWahlrechtspruefungSearchView.COMPONENT_NAME)
@View(viewId = AbstractWahlrechtspruefungSearchView.VIEW_ID, useCase = UseCasePermission.WAHLRECHTSPRUEFUNG_SEARCH)
public abstract class AbstractWahlrechtspruefungSearchView extends AbstractElectSearchView<Wahlrechtspruefung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlrechtspruefungSearchView";
  
  public static final String VIEW_ID = "/wahlrechtspruefung/wahlrechtspruefung-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWahlrechtspruefungSearchView requestHandler;

  @Inject
  private transient WahlrechtspruefungExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WahlrechtspruefungConversationStore.class)
  protected transient WahlrechtspruefungConversationStore conversationStore;

  @Inject
  protected transient WahlrechtspruefungSearch search;

  @Inject
  @ConversationGroup(AbstractWahlrechtspruefungSearchParameters.class)
  protected transient WahlrechtspruefungSearchParameters searchParameters;

  @Inject
  protected transient WahlrechtspruefungMeta entityMeta;

  public AbstractWahlrechtspruefungSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Wahlrechtspruefung getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Wahlrechtspruefung entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WahlrechtspruefungSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Wahlrechtspruefung> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Wahlrechtspruefung> create();
  }

  @Override
  public List<Wahlrechtspruefung> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Wahlrechtspruefung> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWahlrechtspruefungChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlrechtspruefungChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWahlrechtspruefungSearchView {

    @View
    @Inject
    private transient Instance<AbstractWahlrechtspruefungSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWahlrechtspruefungSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
